<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>URIUtil xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/commons/httpclient/util/URIUtil.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/util/URIUtil.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision$</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date$</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em>
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../../org/apache/commons/httpclient/util/package-summary.html">org.apache.commons.httpclient.util</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <strong>import</strong> java.util.BitSet;
<a name="34" href="#34">34</a>  
<a name="35" href="#35">35</a>  <strong>import</strong> org.apache.commons.codec.DecoderException;
<a name="36" href="#36">36</a>  <strong>import</strong> org.apache.commons.codec.net.URLCodec;
<a name="37" href="#37">37</a>  <strong>import</strong> org.apache.commons.httpclient.URI;
<a name="38" href="#38">38</a>  <strong>import</strong> org.apache.commons.httpclient.URIException;
<a name="39" href="#39">39</a>  
<a name="40" href="#40">40</a>  <em>/**<em>*</em></em>
<a name="41" href="#41">41</a>  <em> * The URI escape and character encoding and decoding utility.</em>
<a name="42" href="#42">42</a>  <em> * It's compatible with {@link org.apache.commons.httpclient.HttpURL} rather</em>
<a name="43" href="#43">43</a>  <em> * than {@link org.apache.commons.httpclient.URI}.</em>
<a name="44" href="#44">44</a>  <em> *</em>
<a name="45" href="#45">45</a>  <em> * @author &lt;a href="<a href="mailto:jericho@apache.org" target="alexandria_uri">mailto:jericho@apache.org</a>">Sung-Gu&lt;/a></em>
<a name="46" href="#46">46</a>  <em> * @version $Revision$ $Date: 2002/03/14 15:14:01 </em>
<a name="47" href="#47">47</a>  <em> */</em>
<a name="48" href="#48">48</a>  <strong>public</strong> <strong>class</strong> <a href="../../../../../org/apache/commons/httpclient/util/URIUtil.html">URIUtil</a> {
<a name="49" href="#49">49</a>  
<a name="50" href="#50">50</a>      <em class="comment">// ----------------------------------------------------- Instance variables</em>
<a name="51" href="#51">51</a>  
<a name="52" href="#52">52</a>      <strong>protected</strong> <strong>static</strong> <strong>final</strong> BitSet empty = <strong>new</strong> BitSet(1);
<a name="53" href="#53">53</a>  
<a name="54" href="#54">54</a>      <em class="comment">// ---------------------------------------------------------- URI utilities</em>
<a name="55" href="#55">55</a>  
<a name="56" href="#56">56</a>      <em>/**<em>*</em></em>
<a name="57" href="#57">57</a>  <em>     * Get the basename of an URI.   It's possibly an empty string.</em>
<a name="58" href="#58">58</a>  <em>     *</em>
<a name="59" href="#59">59</a>  <em>     * @param uri a string regarded an URI</em>
<a name="60" href="#60">60</a>  <em>     * @return the basename string; an empty string if the path ends with slash</em>
<a name="61" href="#61">61</a>  <em>     */</em>
<a name="62" href="#62">62</a>      <strong>public</strong> <strong>static</strong> String getName(String uri) {
<a name="63" href="#63">63</a>          <strong>if</strong> (uri == <strong>null</strong> || uri.length() == 0) { <strong>return</strong> uri; } 
<a name="64" href="#64">64</a>          String path = URIUtil.getPath(uri);
<a name="65" href="#65">65</a>          <strong>int</strong> at = path.lastIndexOf(<span class="string">"/"</span>);
<a name="66" href="#66">66</a>          <strong>int</strong> to = path.length();
<a name="67" href="#67">67</a>          <strong>return</strong> (at >= 0) ? path.substring(at + 1, to) : path;
<a name="68" href="#68">68</a>      }
<a name="69" href="#69">69</a>  
<a name="70" href="#70">70</a>  
<a name="71" href="#71">71</a>      <em>/**<em>*</em></em>
<a name="72" href="#72">72</a>  <em>     * Get the query of an URI.</em>
<a name="73" href="#73">73</a>  <em>     *</em>
<a name="74" href="#74">74</a>  <em>     * @param uri a string regarded an URI</em>
<a name="75" href="#75">75</a>  <em>     * @return the query string; &lt;code>null&lt;/code> if empty or undefined</em>
<a name="76" href="#76">76</a>  <em>     */</em>
<a name="77" href="#77">77</a>      <strong>public</strong> <strong>static</strong> String getQuery(String uri) {
<a name="78" href="#78">78</a>          <strong>if</strong> (uri == <strong>null</strong> || uri.length() == 0) { <strong>return</strong> <strong>null</strong>; } 
<a name="79" href="#79">79</a>          <em class="comment">// consider of net_path</em>
<a name="80" href="#80">80</a>          <strong>int</strong> at = uri.indexOf(<span class="string">"//"</span>);
<a name="81" href="#81">81</a>          <strong>int</strong> from = uri.indexOf(
<a name="82" href="#82">82</a>              <span class="string">"/"</span>, 
<a name="83" href="#83">83</a>              at >= 0 ? (uri.lastIndexOf(<span class="string">"/"</span>, at - 1) >= 0 ? 0 : at + 2) : 0
<a name="84" href="#84">84</a>          );
<a name="85" href="#85">85</a>          <em class="comment">// the authority part of URI ignored</em>
<a name="86" href="#86">86</a>          <strong>int</strong> to = uri.length();
<a name="87" href="#87">87</a>          <em class="comment">// reuse the at and from variables to consider the query</em>
<a name="88" href="#88">88</a>          at = uri.indexOf(<span class="string">"?"</span>, from);
<a name="89" href="#89">89</a>          <strong>if</strong> (at >= 0) {
<a name="90" href="#90">90</a>              from = at + 1;
<a name="91" href="#91">91</a>          } <strong>else</strong> {
<a name="92" href="#92">92</a>              <strong>return</strong> <strong>null</strong>;
<a name="93" href="#93">93</a>          }
<a name="94" href="#94">94</a>          <em class="comment">// check the fragment</em>
<a name="95" href="#95">95</a>          <strong>if</strong> (uri.lastIndexOf(<span class="string">"#"</span>) > from) {
<a name="96" href="#96">96</a>              to = uri.lastIndexOf(<span class="string">"#"</span>);
<a name="97" href="#97">97</a>          }
<a name="98" href="#98">98</a>          <em class="comment">// get the path and query.</em>
<a name="99" href="#99">99</a>          <strong>return</strong> (from &lt; 0 || from == to) ? <strong>null</strong> : uri.substring(from, to);
<a name="100" href="#100">100</a>     }
<a name="101" href="#101">101</a> 
<a name="102" href="#102">102</a> 
<a name="103" href="#103">103</a>     <em>/**<em>*</em></em>
<a name="104" href="#104">104</a> <em>     * Get the path of an URI.</em>
<a name="105" href="#105">105</a> <em>     *</em>
<a name="106" href="#106">106</a> <em>     * @param uri a string regarded an URI</em>
<a name="107" href="#107">107</a> <em>     * @return the path string</em>
<a name="108" href="#108">108</a> <em>     */</em>
<a name="109" href="#109">109</a>     <strong>public</strong> <strong>static</strong> String getPath(String uri) {
<a name="110" href="#110">110</a>         <strong>if</strong> (uri == <strong>null</strong>) {
<a name="111" href="#111">111</a>             <strong>return</strong> <strong>null</strong>;
<a name="112" href="#112">112</a>         } 
<a name="113" href="#113">113</a>         <em class="comment">// consider of net_path</em>
<a name="114" href="#114">114</a>         <strong>int</strong> at = uri.indexOf(<span class="string">"//"</span>);
<a name="115" href="#115">115</a>         <strong>int</strong> from = uri.indexOf(
<a name="116" href="#116">116</a>             <span class="string">"/"</span>, 
<a name="117" href="#117">117</a>             at >= 0 ? (uri.lastIndexOf(<span class="string">"/"</span>, at - 1) >= 0 ? 0 : at + 2) : 0
<a name="118" href="#118">118</a>         );
<a name="119" href="#119">119</a>         <em class="comment">// the authority part of URI ignored </em>
<a name="120" href="#120">120</a>         <strong>int</strong> to = uri.length();
<a name="121" href="#121">121</a>         <em class="comment">// check the query</em>
<a name="122" href="#122">122</a>         <strong>if</strong> (uri.indexOf('?', from) != -1) {
<a name="123" href="#123">123</a>             to = uri.indexOf('?', from);
<a name="124" href="#124">124</a>         }
<a name="125" href="#125">125</a>         <em class="comment">// check the fragment</em>
<a name="126" href="#126">126</a>         <strong>if</strong> (uri.lastIndexOf(<span class="string">"#"</span>) > from &amp;&amp; uri.lastIndexOf(<span class="string">"#"</span>) &lt; to) {
<a name="127" href="#127">127</a>             to = uri.lastIndexOf(<span class="string">"#"</span>);
<a name="128" href="#128">128</a>         }
<a name="129" href="#129">129</a>         <em class="comment">// get only the path.</em>
<a name="130" href="#130">130</a>         <strong>return</strong> (from &lt; 0) ? (at >= 0 ? <span class="string">"/"</span> : uri) : uri.substring(from, to);
<a name="131" href="#131">131</a>     }
<a name="132" href="#132">132</a> 
<a name="133" href="#133">133</a> 
<a name="134" href="#134">134</a>     <em>/**<em>*</em></em>
<a name="135" href="#135">135</a> <em>     * Get the path and query of an URI.</em>
<a name="136" href="#136">136</a> <em>     *</em>
<a name="137" href="#137">137</a> <em>     * @param uri a string regarded an URI</em>
<a name="138" href="#138">138</a> <em>     * @return the path and query string</em>
<a name="139" href="#139">139</a> <em>     */</em>
<a name="140" href="#140">140</a>     <strong>public</strong> <strong>static</strong> String getPathQuery(String uri) {
<a name="141" href="#141">141</a>         <strong>if</strong> (uri == <strong>null</strong>) {
<a name="142" href="#142">142</a>             <strong>return</strong> <strong>null</strong>;
<a name="143" href="#143">143</a>         } 
<a name="144" href="#144">144</a>         <em class="comment">// consider of net_path</em>
<a name="145" href="#145">145</a>         <strong>int</strong> at = uri.indexOf(<span class="string">"//"</span>);
<a name="146" href="#146">146</a>         <strong>int</strong> from = uri.indexOf(
<a name="147" href="#147">147</a>             <span class="string">"/"</span>, 
<a name="148" href="#148">148</a>             at >= 0 ? (uri.lastIndexOf(<span class="string">"/"</span>, at - 1) >= 0 ? 0 : at + 2) : 0
<a name="149" href="#149">149</a>         );
<a name="150" href="#150">150</a>         <em class="comment">// the authority part of URI ignored</em>
<a name="151" href="#151">151</a>         <strong>int</strong> to = uri.length();
<a name="152" href="#152">152</a>         <em class="comment">// Ignore the '?' mark so to ignore the query.</em>
<a name="153" href="#153">153</a>         <em class="comment">// check the fragment</em>
<a name="154" href="#154">154</a>         <strong>if</strong> (uri.lastIndexOf(<span class="string">"#"</span>) > from) {
<a name="155" href="#155">155</a>             to = uri.lastIndexOf(<span class="string">"#"</span>);
<a name="156" href="#156">156</a>         }
<a name="157" href="#157">157</a>         <em class="comment">// get the path and query.</em>
<a name="158" href="#158">158</a>         <strong>return</strong> (from &lt; 0) ? (at >= 0 ? <span class="string">"/"</span> : uri) : uri.substring(from, to);
<a name="159" href="#159">159</a>     }
<a name="160" href="#160">160</a> 
<a name="161" href="#161">161</a> 
<a name="162" href="#162">162</a>     <em>/**<em>*</em></em>
<a name="163" href="#163">163</a> <em>     * Get the path of an URI and its rest part.</em>
<a name="164" href="#164">164</a> <em>     *</em>
<a name="165" href="#165">165</a> <em>     * @param uri a string regarded an URI</em>
<a name="166" href="#166">166</a> <em>     * @return the string from the path part</em>
<a name="167" href="#167">167</a> <em>     */</em>
<a name="168" href="#168">168</a>     <strong>public</strong> <strong>static</strong> String getFromPath(String uri) {
<a name="169" href="#169">169</a>         <strong>if</strong> (uri == <strong>null</strong>) {
<a name="170" href="#170">170</a>             <strong>return</strong> <strong>null</strong>;
<a name="171" href="#171">171</a>         } 
<a name="172" href="#172">172</a>         <em class="comment">// consider of net_path</em>
<a name="173" href="#173">173</a>         <strong>int</strong> at = uri.indexOf(<span class="string">"//"</span>);
<a name="174" href="#174">174</a>         <strong>int</strong> from = uri.indexOf(
<a name="175" href="#175">175</a>             <span class="string">"/"</span>, 
<a name="176" href="#176">176</a>             at >= 0 ? (uri.lastIndexOf(<span class="string">"/"</span>, at - 1) >= 0 ? 0 : at + 2) : 0
<a name="177" href="#177">177</a>         );
<a name="178" href="#178">178</a>         <em class="comment">// get the path and its rest.</em>
<a name="179" href="#179">179</a>         <strong>return</strong> (from &lt; 0) ? (at >= 0 ? <span class="string">"/"</span> : uri) : uri.substring(from);
<a name="180" href="#180">180</a>     }
<a name="181" href="#181">181</a> 
<a name="182" href="#182">182</a>     <em class="comment">// ----------------------------------------------------- Encoding utilities</em>
<a name="183" href="#183">183</a> 
<a name="184" href="#184">184</a>     <em>/**<em>*</em></em>
<a name="185" href="#185">185</a> <em>     * Get the all escaped and encoded string with the default protocl charset.</em>
<a name="186" href="#186">186</a> <em>     * It's the same function to use &lt;code>encode(String unescaped, Bitset</em>
<a name="187" href="#187">187</a> <em>     * empty, URI.getDefaultProtocolCharset())&lt;/code>.</em>
<a name="188" href="#188">188</a> <em>     *</em>
<a name="189" href="#189">189</a> <em>     * @param unescaped an unescaped string</em>
<a name="190" href="#190">190</a> <em>     * @return the escaped string</em>
<a name="191" href="#191">191</a> <em>     * </em>
<a name="192" href="#192">192</a> <em>     * @throws URIException if the default protocol charset is not supported</em>
<a name="193" href="#193">193</a> <em>     *</em>
<a name="194" href="#194">194</a> <em>     * @see URI#getDefaultProtocolCharset</em>
<a name="195" href="#195">195</a> <em>     * @see #encode</em>
<a name="196" href="#196">196</a> <em>     */</em>
<a name="197" href="#197">197</a>     <strong>public</strong> <strong>static</strong> String encodeAll(String unescaped) throws URIException {
<a name="198" href="#198">198</a>         <strong>return</strong> encodeAll(unescaped, URI.getDefaultProtocolCharset());
<a name="199" href="#199">199</a>     }
<a name="200" href="#200">200</a>  
<a name="201" href="#201">201</a> 
<a name="202" href="#202">202</a>     <em>/**<em>*</em></em>
<a name="203" href="#203">203</a> <em>     * Get the all escaped and encoded string with a given charset.</em>
<a name="204" href="#204">204</a> <em>     * It's the same function to use &lt;code>encode(String unescaped, Bitset</em>
<a name="205" href="#205">205</a> <em>     * empty, String charset)&lt;/code>.</em>
<a name="206" href="#206">206</a> <em>     *</em>
<a name="207" href="#207">207</a> <em>     * @param unescaped an unescaped string</em>
<a name="208" href="#208">208</a> <em>     * @param charset the charset</em>
<a name="209" href="#209">209</a> <em>     * @return the escaped string</em>
<a name="210" href="#210">210</a> <em>     * </em>
<a name="211" href="#211">211</a> <em>     * @throws URIException if the charset is not supported</em>
<a name="212" href="#212">212</a> <em>     * </em>
<a name="213" href="#213">213</a> <em>     * @see #encode</em>
<a name="214" href="#214">214</a> <em>     */</em>
<a name="215" href="#215">215</a>     <strong>public</strong> <strong>static</strong> String encodeAll(String unescaped, String charset)
<a name="216" href="#216">216</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="217" href="#217">217</a> 
<a name="218" href="#218">218</a>         <strong>return</strong> encode(unescaped, empty, charset);
<a name="219" href="#219">219</a>     }
<a name="220" href="#220">220</a>   
<a name="221" href="#221">221</a> 
<a name="222" href="#222">222</a>     <em>/**<em>*</em></em>
<a name="223" href="#223">223</a> <em>     * Escape and encode a string regarded as within the authority component of</em>
<a name="224" href="#224">224</a> <em>     * an URI with the default protocol charset.</em>
<a name="225" href="#225">225</a> <em>     * Within the authority component, the characters ";", ":", "@", "?", and</em>
<a name="226" href="#226">226</a> <em>     * "/" are reserved.</em>
<a name="227" href="#227">227</a> <em>     *</em>
<a name="228" href="#228">228</a> <em>     * @param unescaped an unescaped string</em>
<a name="229" href="#229">229</a> <em>     * @return the escaped string</em>
<a name="230" href="#230">230</a> <em>     * </em>
<a name="231" href="#231">231</a> <em>     * @throws URIException if the default protocol charset is not supported</em>
<a name="232" href="#232">232</a> <em>     * </em>
<a name="233" href="#233">233</a> <em>     * @see URI#getDefaultProtocolCharset</em>
<a name="234" href="#234">234</a> <em>     * @see #encode</em>
<a name="235" href="#235">235</a> <em>     */</em>
<a name="236" href="#236">236</a>     <strong>public</strong> <strong>static</strong> String encodeWithinAuthority(String unescaped)
<a name="237" href="#237">237</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="238" href="#238">238</a> 
<a name="239" href="#239">239</a>         <strong>return</strong> encodeWithinAuthority(unescaped, URI.getDefaultProtocolCharset());
<a name="240" href="#240">240</a>     }
<a name="241" href="#241">241</a> 
<a name="242" href="#242">242</a> 
<a name="243" href="#243">243</a>     <em>/**<em>*</em></em>
<a name="244" href="#244">244</a> <em>     * Escape and encode a string regarded as within the authority component of</em>
<a name="245" href="#245">245</a> <em>     * an URI with a given charset.</em>
<a name="246" href="#246">246</a> <em>     * Within the authority component, the characters ";", ":", "@", "?", and</em>
<a name="247" href="#247">247</a> <em>     * "/" are reserved.</em>
<a name="248" href="#248">248</a> <em>     *</em>
<a name="249" href="#249">249</a> <em>     * @param unescaped an unescaped string</em>
<a name="250" href="#250">250</a> <em>     * @param charset the charset</em>
<a name="251" href="#251">251</a> <em>     * @return the escaped string</em>
<a name="252" href="#252">252</a> <em>     * </em>
<a name="253" href="#253">253</a> <em>     * @throws URIException if the charset is not supported</em>
<a name="254" href="#254">254</a> <em>     * </em>
<a name="255" href="#255">255</a> <em>     * @see #encode</em>
<a name="256" href="#256">256</a> <em>     */</em>
<a name="257" href="#257">257</a>     <strong>public</strong> <strong>static</strong> String encodeWithinAuthority(String unescaped, String charset)
<a name="258" href="#258">258</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="259" href="#259">259</a> 
<a name="260" href="#260">260</a>         <strong>return</strong> encode(unescaped, URI.allowed_within_authority, charset);
<a name="261" href="#261">261</a>     }
<a name="262" href="#262">262</a> 
<a name="263" href="#263">263</a> 
<a name="264" href="#264">264</a>     <em>/**<em>*</em></em>
<a name="265" href="#265">265</a> <em>     * Escape and encode a string regarded as the path and query components of</em>
<a name="266" href="#266">266</a> <em>     * an URI with the default protocol charset.</em>
<a name="267" href="#267">267</a> <em>     *</em>
<a name="268" href="#268">268</a> <em>     * @param unescaped an unescaped string</em>
<a name="269" href="#269">269</a> <em>     * @return the escaped string</em>
<a name="270" href="#270">270</a> <em>     * </em>
<a name="271" href="#271">271</a> <em>     * @throws URIException if the default protocol charset is not supported</em>
<a name="272" href="#272">272</a> <em>     * </em>
<a name="273" href="#273">273</a> <em>     * @see URI#getDefaultProtocolCharset</em>
<a name="274" href="#274">274</a> <em>     * @see #encode</em>
<a name="275" href="#275">275</a> <em>     */</em>
<a name="276" href="#276">276</a>     <strong>public</strong> <strong>static</strong> String encodePathQuery(String unescaped) throws URIException {
<a name="277" href="#277">277</a>         <strong>return</strong> encodePathQuery(unescaped, URI.getDefaultProtocolCharset());
<a name="278" href="#278">278</a>     }
<a name="279" href="#279">279</a> 
<a name="280" href="#280">280</a> 
<a name="281" href="#281">281</a>     <em>/**<em>*</em></em>
<a name="282" href="#282">282</a> <em>     * Escape and encode a string regarded as the path and query components of</em>
<a name="283" href="#283">283</a> <em>     * an URI with a given charset.</em>
<a name="284" href="#284">284</a> <em>     *</em>
<a name="285" href="#285">285</a> <em>     * @param unescaped an unescaped string</em>
<a name="286" href="#286">286</a> <em>     * @param charset the charset</em>
<a name="287" href="#287">287</a> <em>     * @return the escaped string</em>
<a name="288" href="#288">288</a> <em>     * </em>
<a name="289" href="#289">289</a> <em>     * @throws URIException if the charset is not supported</em>
<a name="290" href="#290">290</a> <em>     * </em>
<a name="291" href="#291">291</a> <em>     * @see #encode</em>
<a name="292" href="#292">292</a> <em>     */</em>
<a name="293" href="#293">293</a>     <strong>public</strong> <strong>static</strong> String encodePathQuery(String unescaped, String charset)
<a name="294" href="#294">294</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="295" href="#295">295</a> 
<a name="296" href="#296">296</a>         <strong>int</strong> at = unescaped.indexOf('?');
<a name="297" href="#297">297</a>         <strong>if</strong> (at &lt; 0) {
<a name="298" href="#298">298</a>             <strong>return</strong> encode(unescaped, URI.allowed_abs_path, charset);
<a name="299" href="#299">299</a>         }
<a name="300" href="#300">300</a>         <em class="comment">// else</em>
<a name="301" href="#301">301</a>         <strong>return</strong>  encode(unescaped.substring(0, at), URI.allowed_abs_path, charset)
<a name="302" href="#302">302</a>             + '?' + encode(unescaped.substring(at + 1), URI.allowed_query, charset);
<a name="303" href="#303">303</a>     }
<a name="304" href="#304">304</a> 
<a name="305" href="#305">305</a> 
<a name="306" href="#306">306</a>     <em>/**<em>*</em></em>
<a name="307" href="#307">307</a> <em>     * Escape and encode a string regarded as within the path component of an</em>
<a name="308" href="#308">308</a> <em>     * URI with the default protocol charset.</em>
<a name="309" href="#309">309</a> <em>     * The path may consist of a sequence of path segments separated by a</em>
<a name="310" href="#310">310</a> <em>     * single slash "/" character.  Within a path segment, the characters</em>
<a name="311" href="#311">311</a> <em>     * "/", ";", "=", and "?" are reserved.</em>
<a name="312" href="#312">312</a> <em>     *</em>
<a name="313" href="#313">313</a> <em>     * @param unescaped an unescaped string</em>
<a name="314" href="#314">314</a> <em>     * @return the escaped string</em>
<a name="315" href="#315">315</a> <em>     * </em>
<a name="316" href="#316">316</a> <em>     * @throws URIException if the default protocol charset is not supported</em>
<a name="317" href="#317">317</a> <em>     * </em>
<a name="318" href="#318">318</a> <em>     * @see URI#getDefaultProtocolCharset</em>
<a name="319" href="#319">319</a> <em>     * @see #encode</em>
<a name="320" href="#320">320</a> <em>     */</em>
<a name="321" href="#321">321</a>     <strong>public</strong> <strong>static</strong> String encodeWithinPath(String unescaped)
<a name="322" href="#322">322</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="323" href="#323">323</a> 
<a name="324" href="#324">324</a>         <strong>return</strong> encodeWithinPath(unescaped, URI.getDefaultProtocolCharset());
<a name="325" href="#325">325</a>     }
<a name="326" href="#326">326</a> 
<a name="327" href="#327">327</a> 
<a name="328" href="#328">328</a>     <em>/**<em>*</em></em>
<a name="329" href="#329">329</a> <em>     * Escape and encode a string regarded as within the path component of an</em>
<a name="330" href="#330">330</a> <em>     * URI with a given charset.</em>
<a name="331" href="#331">331</a> <em>     * The path may consist of a sequence of path segments separated by a</em>
<a name="332" href="#332">332</a> <em>     * single slash "/" character.  Within a path segment, the characters</em>
<a name="333" href="#333">333</a> <em>     * "/", ";", "=", and "?" are reserved.</em>
<a name="334" href="#334">334</a> <em>     *</em>
<a name="335" href="#335">335</a> <em>     * @param unescaped an unescaped string</em>
<a name="336" href="#336">336</a> <em>     * @param charset the charset</em>
<a name="337" href="#337">337</a> <em>     * @return the escaped string</em>
<a name="338" href="#338">338</a> <em>     * </em>
<a name="339" href="#339">339</a> <em>     * @throws URIException if the charset is not supported</em>
<a name="340" href="#340">340</a> <em>     * </em>
<a name="341" href="#341">341</a> <em>     * @see #encode</em>
<a name="342" href="#342">342</a> <em>     */</em>
<a name="343" href="#343">343</a>     <strong>public</strong> <strong>static</strong> String encodeWithinPath(String unescaped, String charset)
<a name="344" href="#344">344</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="345" href="#345">345</a> 
<a name="346" href="#346">346</a>         <strong>return</strong> encode(unescaped, URI.allowed_within_path, charset);
<a name="347" href="#347">347</a>     }
<a name="348" href="#348">348</a> 
<a name="349" href="#349">349</a> 
<a name="350" href="#350">350</a>     <em>/**<em>*</em></em>
<a name="351" href="#351">351</a> <em>     * Escape and encode a string regarded as the path component of an URI with</em>
<a name="352" href="#352">352</a> <em>     * the default protocol charset.</em>
<a name="353" href="#353">353</a> <em>     *</em>
<a name="354" href="#354">354</a> <em>     * @param unescaped an unescaped string</em>
<a name="355" href="#355">355</a> <em>     * @return the escaped string</em>
<a name="356" href="#356">356</a> <em>     * </em>
<a name="357" href="#357">357</a> <em>     * @throws URIException if the default protocol charset is not supported</em>
<a name="358" href="#358">358</a> <em>     * </em>
<a name="359" href="#359">359</a> <em>     * @see URI#getDefaultProtocolCharset</em>
<a name="360" href="#360">360</a> <em>     * @see #encode</em>
<a name="361" href="#361">361</a> <em>     */</em>
<a name="362" href="#362">362</a>     <strong>public</strong> <strong>static</strong> String encodePath(String unescaped) throws URIException {
<a name="363" href="#363">363</a>         <strong>return</strong> encodePath(unescaped, URI.getDefaultProtocolCharset());
<a name="364" href="#364">364</a>     }
<a name="365" href="#365">365</a> 
<a name="366" href="#366">366</a> 
<a name="367" href="#367">367</a>     <em>/**<em>*</em></em>
<a name="368" href="#368">368</a> <em>     * Escape and encode a string regarded as the path component of an URI with</em>
<a name="369" href="#369">369</a> <em>     * a given charset.</em>
<a name="370" href="#370">370</a> <em>     *</em>
<a name="371" href="#371">371</a> <em>     * @param unescaped an unescaped string</em>
<a name="372" href="#372">372</a> <em>     * @param charset the charset</em>
<a name="373" href="#373">373</a> <em>     * @return the escaped string</em>
<a name="374" href="#374">374</a> <em>     * </em>
<a name="375" href="#375">375</a> <em>     * @throws URIException if the charset is not supported</em>
<a name="376" href="#376">376</a> <em>     * </em>
<a name="377" href="#377">377</a> <em>     * @see #encode</em>
<a name="378" href="#378">378</a> <em>     */</em>
<a name="379" href="#379">379</a>     <strong>public</strong> <strong>static</strong> String encodePath(String unescaped, String charset)
<a name="380" href="#380">380</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="381" href="#381">381</a> 
<a name="382" href="#382">382</a>         <strong>return</strong> encode(unescaped, URI.allowed_abs_path, charset);
<a name="383" href="#383">383</a>     }
<a name="384" href="#384">384</a> 
<a name="385" href="#385">385</a> 
<a name="386" href="#386">386</a>     <em>/**<em>*</em></em>
<a name="387" href="#387">387</a> <em>     * Escape and encode a string regarded as within the query component of an</em>
<a name="388" href="#388">388</a> <em>     * URI with the default protocol charset.</em>
<a name="389" href="#389">389</a> <em>     * When a query comprise the name and value pairs, it is used in order</em>
<a name="390" href="#390">390</a> <em>     * to encode each name and value string.  The reserved special characters</em>
<a name="391" href="#391">391</a> <em>     * within a query component are being included in encoding the query.</em>
<a name="392" href="#392">392</a> <em>     *</em>
<a name="393" href="#393">393</a> <em>     * @param unescaped an unescaped string</em>
<a name="394" href="#394">394</a> <em>     * @return the escaped string</em>
<a name="395" href="#395">395</a> <em>     * </em>
<a name="396" href="#396">396</a> <em>     * @throws URIException if the default protocol charset is not supported</em>
<a name="397" href="#397">397</a> <em>     * </em>
<a name="398" href="#398">398</a> <em>     * @see URI#getDefaultProtocolCharset</em>
<a name="399" href="#399">399</a> <em>     * @see #encode</em>
<a name="400" href="#400">400</a> <em>     */</em>
<a name="401" href="#401">401</a>     <strong>public</strong> <strong>static</strong> String encodeWithinQuery(String unescaped)
<a name="402" href="#402">402</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="403" href="#403">403</a> 
<a name="404" href="#404">404</a>         <strong>return</strong> encodeWithinQuery(unescaped, URI.getDefaultProtocolCharset());
<a name="405" href="#405">405</a>     }
<a name="406" href="#406">406</a> 
<a name="407" href="#407">407</a> 
<a name="408" href="#408">408</a>     <em>/**<em>*</em></em>
<a name="409" href="#409">409</a> <em>     * Escape and encode a string regarded as within the query component of an</em>
<a name="410" href="#410">410</a> <em>     * URI with a given charset.</em>
<a name="411" href="#411">411</a> <em>     * When a query comprise the name and value pairs, it is used in order</em>
<a name="412" href="#412">412</a> <em>     * to encode each name and value string.  The reserved special characters</em>
<a name="413" href="#413">413</a> <em>     * within a query component are being included in encoding the query.</em>
<a name="414" href="#414">414</a> <em>     *</em>
<a name="415" href="#415">415</a> <em>     * @param unescaped an unescaped string</em>
<a name="416" href="#416">416</a> <em>     * @param charset the charset</em>
<a name="417" href="#417">417</a> <em>     * @return the escaped string</em>
<a name="418" href="#418">418</a> <em>     * </em>
<a name="419" href="#419">419</a> <em>     * @throws URIException if the charset is not supported</em>
<a name="420" href="#420">420</a> <em>     * </em>
<a name="421" href="#421">421</a> <em>     * @see #encode</em>
<a name="422" href="#422">422</a> <em>     */</em>
<a name="423" href="#423">423</a>     <strong>public</strong> <strong>static</strong> String encodeWithinQuery(String unescaped, String charset)
<a name="424" href="#424">424</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="425" href="#425">425</a> 
<a name="426" href="#426">426</a>         <strong>return</strong> encode(unescaped, URI.allowed_within_query, charset);
<a name="427" href="#427">427</a>     }
<a name="428" href="#428">428</a> 
<a name="429" href="#429">429</a> 
<a name="430" href="#430">430</a>     <em>/**<em>*</em></em>
<a name="431" href="#431">431</a> <em>     * Escape and encode a string regarded as the query component of an URI with</em>
<a name="432" href="#432">432</a> <em>     * the default protocol charset.</em>
<a name="433" href="#433">433</a> <em>     * When a query string is not misunderstood the reserved special characters</em>
<a name="434" href="#434">434</a> <em>     * ("&amp;amp;", "=", "+", ",", and "$") within a query component, this method</em>
<a name="435" href="#435">435</a> <em>     * is recommended to use in encoding the whole query.</em>
<a name="436" href="#436">436</a> <em>     *</em>
<a name="437" href="#437">437</a> <em>     * @param unescaped an unescaped string</em>
<a name="438" href="#438">438</a> <em>     * @return the escaped string</em>
<a name="439" href="#439">439</a> <em>     * </em>
<a name="440" href="#440">440</a> <em>     * @throws URIException if the default protocol charset is not supported</em>
<a name="441" href="#441">441</a> <em>     * </em>
<a name="442" href="#442">442</a> <em>     * @see URI#getDefaultProtocolCharset</em>
<a name="443" href="#443">443</a> <em>     * @see #encode</em>
<a name="444" href="#444">444</a> <em>     */</em>
<a name="445" href="#445">445</a>     <strong>public</strong> <strong>static</strong> String encodeQuery(String unescaped) throws URIException {
<a name="446" href="#446">446</a>         <strong>return</strong> encodeQuery(unescaped, URI.getDefaultProtocolCharset());
<a name="447" href="#447">447</a>     }
<a name="448" href="#448">448</a> 
<a name="449" href="#449">449</a> 
<a name="450" href="#450">450</a>     <em>/**<em>*</em></em>
<a name="451" href="#451">451</a> <em>     * Escape and encode a string regarded as the query component of an URI with</em>
<a name="452" href="#452">452</a> <em>     * a given charset.</em>
<a name="453" href="#453">453</a> <em>     * When a query string is not misunderstood the reserved special characters</em>
<a name="454" href="#454">454</a> <em>     * ("&amp;amp;", "=", "+", ",", and "$") within a query component, this method</em>
<a name="455" href="#455">455</a> <em>     * is recommended to use in encoding the whole query.</em>
<a name="456" href="#456">456</a> <em>     *</em>
<a name="457" href="#457">457</a> <em>     * @param unescaped an unescaped string</em>
<a name="458" href="#458">458</a> <em>     * @param charset the charset</em>
<a name="459" href="#459">459</a> <em>     * @return the escaped string</em>
<a name="460" href="#460">460</a> <em>     * </em>
<a name="461" href="#461">461</a> <em>     * @throws URIException if the charset is not supported</em>
<a name="462" href="#462">462</a> <em>     * </em>
<a name="463" href="#463">463</a> <em>     * @see #encode</em>
<a name="464" href="#464">464</a> <em>     */</em>
<a name="465" href="#465">465</a>     <strong>public</strong> <strong>static</strong> String encodeQuery(String unescaped, String charset)
<a name="466" href="#466">466</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="467" href="#467">467</a> 
<a name="468" href="#468">468</a>         <strong>return</strong> encode(unescaped, URI.allowed_query, charset);
<a name="469" href="#469">469</a>     }
<a name="470" href="#470">470</a> 
<a name="471" href="#471">471</a> 
<a name="472" href="#472">472</a>     <em>/**<em>*</em></em>
<a name="473" href="#473">473</a> <em>     * Escape and encode a given string with allowed characters not to be</em>
<a name="474" href="#474">474</a> <em>     * escaped and the default protocol charset.</em>
<a name="475" href="#475">475</a> <em>     *</em>
<a name="476" href="#476">476</a> <em>     * @param unescaped a string</em>
<a name="477" href="#477">477</a> <em>     * @param allowed allowed characters not to be escaped</em>
<a name="478" href="#478">478</a> <em>     * @return the escaped string</em>
<a name="479" href="#479">479</a> <em>     * </em>
<a name="480" href="#480">480</a> <em>     * @throws URIException if the default protocol charset is not supported</em>
<a name="481" href="#481">481</a> <em>     * </em>
<a name="482" href="#482">482</a> <em>     * @see URI#getDefaultProtocolCharset</em>
<a name="483" href="#483">483</a> <em>     */</em>
<a name="484" href="#484">484</a>     <strong>public</strong> <strong>static</strong> String encode(String unescaped, BitSet allowed)
<a name="485" href="#485">485</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="486" href="#486">486</a> 
<a name="487" href="#487">487</a>         <strong>return</strong> encode(unescaped, allowed, URI.getDefaultProtocolCharset());
<a name="488" href="#488">488</a>     }
<a name="489" href="#489">489</a> 
<a name="490" href="#490">490</a> 
<a name="491" href="#491">491</a>     <em>/**<em>*</em></em>
<a name="492" href="#492">492</a> <em>     * Escape and encode a given string with allowed characters not to be</em>
<a name="493" href="#493">493</a> <em>     * escaped and a given charset.</em>
<a name="494" href="#494">494</a> <em>     *</em>
<a name="495" href="#495">495</a> <em>     * @param unescaped a string</em>
<a name="496" href="#496">496</a> <em>     * @param allowed allowed characters not to be escaped</em>
<a name="497" href="#497">497</a> <em>     * @param charset the charset</em>
<a name="498" href="#498">498</a> <em>     * @return the escaped string</em>
<a name="499" href="#499">499</a> <em>     */</em>
<a name="500" href="#500">500</a>     <strong>public</strong> <strong>static</strong> String encode(String unescaped, BitSet allowed,
<a name="501" href="#501">501</a>             String charset) throws URIException {
<a name="502" href="#502">502</a>         byte[] rawdata = URLCodec.encodeUrl(allowed, 
<a name="503" href="#503">503</a>             EncodingUtil.getBytes(unescaped, charset));
<a name="504" href="#504">504</a>         <strong>return</strong> EncodingUtil.getAsciiString(rawdata);
<a name="505" href="#505">505</a>     }
<a name="506" href="#506">506</a> 
<a name="507" href="#507">507</a> 
<a name="508" href="#508">508</a>     <em>/**<em>*</em></em>
<a name="509" href="#509">509</a> <em>     * Unescape and decode a given string regarded as an escaped string with the</em>
<a name="510" href="#510">510</a> <em>     * default protocol charset.</em>
<a name="511" href="#511">511</a> <em>     *</em>
<a name="512" href="#512">512</a> <em>     * @param escaped a string</em>
<a name="513" href="#513">513</a> <em>     * @return the unescaped string</em>
<a name="514" href="#514">514</a> <em>     * </em>
<a name="515" href="#515">515</a> <em>     * @throws URIException if the string cannot be decoded (invalid)</em>
<a name="516" href="#516">516</a> <em>     * </em>
<a name="517" href="#517">517</a> <em>     * @see URI#getDefaultProtocolCharset</em>
<a name="518" href="#518">518</a> <em>     */</em>
<a name="519" href="#519">519</a>     <strong>public</strong> <strong>static</strong> String decode(String escaped) throws URIException {
<a name="520" href="#520">520</a>         <strong>try</strong> {
<a name="521" href="#521">521</a>             byte[] rawdata = URLCodec.decodeUrl(EncodingUtil.getAsciiBytes(escaped));
<a name="522" href="#522">522</a>             <strong>return</strong> EncodingUtil.getString(rawdata, URI.getDefaultProtocolCharset());
<a name="523" href="#523">523</a>         } <strong>catch</strong> (DecoderException e) {
<a name="524" href="#524">524</a>             <strong>throw</strong> <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a>(e.getMessage());
<a name="525" href="#525">525</a>         }
<a name="526" href="#526">526</a>     }
<a name="527" href="#527">527</a> 
<a name="528" href="#528">528</a>     <em>/**<em>*</em></em>
<a name="529" href="#529">529</a> <em>     * Unescape and decode a given string regarded as an escaped string.</em>
<a name="530" href="#530">530</a> <em>     *</em>
<a name="531" href="#531">531</a> <em>     * @param escaped a string</em>
<a name="532" href="#532">532</a> <em>     * @param charset the charset</em>
<a name="533" href="#533">533</a> <em>     * @return the unescaped string</em>
<a name="534" href="#534">534</a> <em>     * </em>
<a name="535" href="#535">535</a> <em>     * @throws URIException if the charset is not supported</em>
<a name="536" href="#536">536</a> <em>     * </em>
<a name="537" href="#537">537</a> <em>     * @see Coder#decode</em>
<a name="538" href="#538">538</a> <em>     */</em>
<a name="539" href="#539">539</a>     <strong>public</strong> <strong>static</strong> String decode(String escaped, String charset)
<a name="540" href="#540">540</a>         throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="541" href="#541">541</a> 
<a name="542" href="#542">542</a>         <strong>return</strong> Coder.decode(escaped.toCharArray(), charset);
<a name="543" href="#543">543</a>     }
<a name="544" href="#544">544</a> 
<a name="545" href="#545">545</a>     <em class="comment">// ---------------------------------------------------------- Inner classes</em>
<a name="546" href="#546">546</a> 
<a name="547" href="#547">547</a>     <em>/**<em>*</em></em>
<a name="548" href="#548">548</a> <em>     * The basic and internal utility for URI escape and character encoding and</em>
<a name="549" href="#549">549</a> <em>     * decoding.</em>
<a name="550" href="#550">550</a> <em>     * </em>
<a name="551" href="#551">551</a> <em>     * @deprecated use org.apache.commons.codec.net.URLCodec</em>
<a name="552" href="#552">552</a> <em>     */</em>
<a name="553" href="#553">553</a>     <strong>protected</strong> <strong>static</strong> <strong>class</strong> Coder <strong>extends</strong> <a href="../../../../../org/apache/commons/httpclient/URI.html">URI</a> {
<a name="554" href="#554">554</a> 
<a name="555" href="#555">555</a>         <em>/**<em>*</em></em>
<a name="556" href="#556">556</a> <em>         * Escape and encode a given string with allowed characters not to be</em>
<a name="557" href="#557">557</a> <em>         * escaped.</em>
<a name="558" href="#558">558</a> <em>         *</em>
<a name="559" href="#559">559</a> <em>         * @param unescapedComponent an unescaped component</em>
<a name="560" href="#560">560</a> <em>         * @param allowed allowed characters not to be escaped</em>
<a name="561" href="#561">561</a> <em>         * @param charset the charset to encode</em>
<a name="562" href="#562">562</a> <em>         * @return the escaped and encoded string</em>
<a name="563" href="#563">563</a> <em>         * </em>
<a name="564" href="#564">564</a> <em>         * @throws URIException if the charset is not supported</em>
<a name="565" href="#565">565</a> <em>         * </em>
<a name="566" href="#566">566</a> <em>         * @deprecated use org.apache.commons.codec.net.URLCodec</em>
<a name="567" href="#567">567</a> <em>         */</em>
<a name="568" href="#568">568</a>         <strong>public</strong> <strong>static</strong> <strong>char</strong>[] encode(String unescapedComponent, BitSet allowed, String <strong>char</strong>set) 
<a name="569" href="#569">569</a>             throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="570" href="#570">570</a> 
<a name="571" href="#571">571</a>             <strong>return</strong> URI.encode(unescapedComponent, allowed, charset);
<a name="572" href="#572">572</a>         }
<a name="573" href="#573">573</a> 
<a name="574" href="#574">574</a> 
<a name="575" href="#575">575</a>         <em>/**<em>*</em></em>
<a name="576" href="#576">576</a> <em>         * Unescape and decode a given string.</em>
<a name="577" href="#577">577</a> <em>         *</em>
<a name="578" href="#578">578</a> <em>         * @param escapedComponent an being-unescaped component</em>
<a name="579" href="#579">579</a> <em>         * @param charset the charset to decode</em>
<a name="580" href="#580">580</a> <em>         * @return the escaped and encoded string</em>
<a name="581" href="#581">581</a> <em>         * </em>
<a name="582" href="#582">582</a> <em>         * @throws URIException if the charset is not supported</em>
<a name="583" href="#583">583</a> <em>         * </em>
<a name="584" href="#584">584</a> <em>         * @deprecated use org.apache.commons.codec.net.URLCodec</em>
<a name="585" href="#585">585</a> <em>         */</em>
<a name="586" href="#586">586</a>         <strong>public</strong> <strong>static</strong> String decode(<strong>char</strong>[] escapedComponent, String <strong>char</strong>set)
<a name="587" href="#587">587</a>             throws <a href="../../../../../org/apache/commons/httpclient/URIException.html">URIException</a> {
<a name="588" href="#588">588</a> 
<a name="589" href="#589">589</a>             <strong>return</strong> URI.decode(escapedComponent, charset);
<a name="590" href="#590">590</a>         }
<a name="591" href="#591">591</a> 
<a name="592" href="#592">592</a> 
<a name="593" href="#593">593</a>         <em>/**<em>*</em></em>
<a name="594" href="#594">594</a> <em>         * Verify whether a given string is escaped or not</em>
<a name="595" href="#595">595</a> <em>         *</em>
<a name="596" href="#596">596</a> <em>         * @param original given characters</em>
<a name="597" href="#597">597</a> <em>         * @return true if the given character array is 7 bit ASCII-compatible.</em>
<a name="598" href="#598">598</a> <em>         */</em>
<a name="599" href="#599">599</a>         <strong>public</strong> <strong>static</strong> <strong>boolean</strong> verifyEscaped(<strong>char</strong>[] original) {
<a name="600" href="#600">600</a>             <strong>for</strong> (<strong>int</strong> i = 0; i &lt; original.length; i++) {
<a name="601" href="#601">601</a>                 <strong>int</strong> c = original[i];
<a name="602" href="#602">602</a>                 <strong>if</strong> (c > 128) {
<a name="603" href="#603">603</a>                     <strong>return</strong> false;
<a name="604" href="#604">604</a>                 } <strong>else</strong> <strong>if</strong> (c == '%') {
<a name="605" href="#605">605</a>                     <strong>if</strong> (Character.digit(original[++i], 16) == -1 
<a name="606" href="#606">606</a>                         || Character.digit(original[++i], 16) == -1) {
<a name="607" href="#607">607</a>                         <strong>return</strong> false;
<a name="608" href="#608">608</a>                     }
<a name="609" href="#609">609</a>                 }
<a name="610" href="#610">610</a>             }
<a name="611" href="#611">611</a>             <strong>return</strong> <strong>true</strong>;
<a name="612" href="#612">612</a>         }
<a name="613" href="#613">613</a> 
<a name="614" href="#614">614</a> 
<a name="615" href="#615">615</a>         <em>/**<em>*</em></em>
<a name="616" href="#616">616</a> <em>         * Replace from a given character to given character in an array order</em>
<a name="617" href="#617">617</a> <em>         * for a given string.</em>
<a name="618" href="#618">618</a> <em>         *</em>
<a name="619" href="#619">619</a> <em>         * @param original a given string</em>
<a name="620" href="#620">620</a> <em>         * @param from a replacing character array</em>
<a name="621" href="#621">621</a> <em>         * @param to a replaced character array</em>
<a name="622" href="#622">622</a> <em>         * @return the replaced string</em>
<a name="623" href="#623">623</a> <em>         */</em>
<a name="624" href="#624">624</a>         <strong>public</strong> <strong>static</strong> String replace(String original, <strong>char</strong>[] from, <strong>char</strong>[] to) {
<a name="625" href="#625">625</a>             <strong>for</strong> (<strong>int</strong> i = from.length; i > 0; --i) {
<a name="626" href="#626">626</a>                 original = replace(original, from[i], to[i]);
<a name="627" href="#627">627</a>             }
<a name="628" href="#628">628</a>             <strong>return</strong> original;
<a name="629" href="#629">629</a>         }
<a name="630" href="#630">630</a> 
<a name="631" href="#631">631</a> 
<a name="632" href="#632">632</a>         <em>/**<em>*</em></em>
<a name="633" href="#633">633</a> <em>         * Replace from a given character to given character for a given string.</em>
<a name="634" href="#634">634</a> <em>         *</em>
<a name="635" href="#635">635</a> <em>         * @param original a given string</em>
<a name="636" href="#636">636</a> <em>         * @param from a replacing character array</em>
<a name="637" href="#637">637</a> <em>         * @param to a replaced character array</em>
<a name="638" href="#638">638</a> <em>         * @return the replaced string</em>
<a name="639" href="#639">639</a> <em>         */</em>
<a name="640" href="#640">640</a>         <strong>public</strong> <strong>static</strong> String replace(String original, <strong>char</strong> from, <strong>char</strong> to) {
<a name="641" href="#641">641</a>             StringBuffer result = <strong>new</strong> StringBuffer(original.length());
<a name="642" href="#642">642</a>             <strong>int</strong> at, saved = 0;
<a name="643" href="#643">643</a>             <strong>do</strong> {
<a name="644" href="#644">644</a>                 at = original.indexOf(from);
<a name="645" href="#645">645</a>                 <strong>if</strong> (at >= 0) {
<a name="646" href="#646">646</a>                     result.append(original.substring(0, at));
<a name="647" href="#647">647</a>                     result.append(to);
<a name="648" href="#648">648</a>                 } <strong>else</strong> {
<a name="649" href="#649">649</a>                     result.append(original.substring(saved));
<a name="650" href="#650">650</a>                 }
<a name="651" href="#651">651</a>                 saved = at;
<a name="652" href="#652">652</a>             } <strong>while</strong> (at >= 0);
<a name="653" href="#653">653</a>             <strong>return</strong> result.toString();
<a name="654" href="#654">654</a>         }
<a name="655" href="#655">655</a>     }
<a name="656" href="#656">656</a> 
<a name="657" href="#657">657</a> }
<a name="658" href="#658">658</a> 
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

